﻿using System;
using System.Collections.Generic;
using System.Drawing;
using Wisej.Web;
using static System.Net.WebRequestMethods;

namespace Wisej_DragDropSample
{
	public partial class btnPdf : Page
	{


        private List<Button> _selectedButtonList = new List<Button>();


        public btnPdf()
		{
			InitializeComponent();
		}

		private void Page1_Load(object sender, System.EventArgs e)
		{
			FixDragDropForButton();

			//var label = new Label
			//{
			//	Text = "Drag me label",
			//	AllowDrag = true,
			//	Parent = this.flowLayoutPanel1
			//};
			//label.DragStart += Control_DragStart;	


			var button = new Button
			{
				Text = "Button One",
				AllowDrag = true,
				Parent = this.flpSource,
				BackColor = Color.Blue
			};

			button.Click += new System.EventHandler(OrderButton_Click);
			button.DragStart += Control_DragStart;

			button = new Button
			{
				Text = "Button Two",
				AllowDrag = true,
				Parent = this.flpSource,
				BackColor = Color.Blue
            };

			button.Click += new System.EventHandler(OrderButton_Click);
			button.DragStart += Control_DragStart;


			/*
						var btnCtrlReferenceX = new Button
						{
						Text = "DragAzzBak",
						BackColor = Color.Green,
						AllowDrag = true,
						Parent = this.flowLayoutPanel2
						};
						btnCtrlReferenceX.DragStart += Control_DragStart;
			*/

			// btnCtrlReferenceX.Click += ButtonAzzBak_Click;  NonFunctional Abstract


			if (!flpSource.AllowDrop)
			{ this.flpSource.AllowDrop = true; }

			if (!flpDestination.AllowDrop)
			{ this.flpDestination.AllowDrop = true; }


			////this.flowLayoutPanel1.DragEnter += Panel_DragEnter;
			////this.flowLayoutPanel2.DragEnter += Panel_DragEnter;

			this.flpSource.DragDrop += Panel_DragDrop;
			this.flpDestination.DragDrop += Panel_DragDrop;
		}



		private void OrderButton_Click(object sender, EventArgs e)
		{
			Button btnSelected = (Button)sender;

			if (!_selectedButtonList.Contains(btnSelected))
			{
				//btnSelected.BackColor = Color.White;                        //		WhiteSmoke
				btnSelected.BackColor = Color.Red;
				_selectedButtonList.Add(btnSelected);
			}
			else
			{
                btnSelected.BackColor = Color.White;
                _selectedButtonList.Remove(btnSelected);
            }						            
		}


        private void Panel_DragDrop(object sender, DragEventArgs e)
		{
			var panel = (Control)sender;
			var control = e.DragSource;
			if (control != null)
			{
				control.Parent = panel;
			}
		}
        // One Way ===>   receiver gets        this.pnlOrders.DragDrop += new Wisej.Web.DragEventHandler(this.UnloadTruck);

        ////      private void Panel_DragEnter(object sender, DragEventArgs e)
        ////{
        ////	e.Effect = DragDropEffects.Move;
        ////}



        private void Control_DragStart(object sender, System.EventArgs e)
        {
            var selBtnCtrl = (Button)sender;

       
            if (_selectedButtonList.Count > 0)
            {
				foreach (Button selBtn in _selectedButtonList)
				{
					if (_selectedButtonList.Contains(selBtn))
					{
						//selBtn.DoDragDrop(null, DragDropEffects.Move);
						flpSource.Controls.Remove(selBtn);
						flpDestination.Controls.Add(selBtn);
						//_selectedButtonList.Remove(selBtn);
					}
				}
				_selectedButtonList.Clear();
            }
        }













        private void FixDragDropForButton()
        {
            this.InitScript = @"
				var dragDrop = qx.event.Registration.getManager(window).getHandler(qx.event.handler.DragDrop);
				dragDrop.__manager.removeListener(dragDrop.__root, ""pointerdown"", dragDrop._onPointerdown, dragDrop);
				dragDrop.__manager.addListener(dragDrop.__root, ""pointerdown"", dragDrop._onPointerdown, dragDrop, true);";
        }

		private void button1_Click(object sender, EventArgs e)
		{

			//string strUrl = "http://xe-emerald-dev/TestDeploy/Documents/PDFViewer.aspx?DOCUMENT_ID=639143";
			//string strUrl = "http://xe-emerald-dev/TestDeploy/Documents/PDFViewer.aspx?DOCUMENT_ID=639143" + "target=\"_blank\"";
			//System.Diagnostics.Process.Start("http://xe-emerald-dev/TestDeploy/Documents/PDFViewer.aspx?DOCUMENT_ID=639143");
			//Application.Navigate(strUrl);

			Page1_Load(sender, e);



        }


    }
}




////private void Control_DragStart(object sender, System.EventArgs e)
////{
////	var control = (Control)sender;

////	string strError = "DoDragDrop Multi Completed ";
////	////var toast = new Toast
////	////{
////	////	Text = strError,
////	////	Alignment = System.Drawing.ContentAlignment.MiddleCenter,
////	////	AutoCloseDelay = 3500,
////	////	AutoDispose = true,
////	////};


////	if (_selectedButtonList.Count > 0)
////	{

////		//foreach(Button selBtn in _selectedButtonList)

////		foreach (Button selBtn in flpSource.Controls)
////		{
////			try
////			{
////				flpSource.Controls.Remove(selBtn);

////				if (_selectedButtonList.Contains(selBtn))
////				{
////					//			selBtn.DoDragDrop(selBtn, DragDropEffects.Move);    // Shouldnt this handle the work for me 

////                          flpSource.Controls.Remove(selBtn); 
////					flpDestination.Controls.Add(selBtn);
////					//_selectedButtonList.Remove(selBtn);
////				}
////			}
////			catch (Exception DnDError)
////			{		throw DnDError;		}


////                  //_selectedButtonList.Clear();	


////                  //flpMain.Controls.Remove(selBtn);
////              }


////		////toast.Show();


////	}
////}





/*
private void ButtonAzzBak_Click(object sender, EventArgs e)
{
    // This doesnt work it doesnt know destination panel 
    Control_DragStart(sender, e);
}
*/